@echo off
REM Utility to create symbolic directory links for RDP drive redirection to reach user documents/desktop for a given remote user name.
REM Copyright  TempWorks Software, Inc. 
REM Support@TempWorks.com

:: BatchGotAdmin
:-------------------------------------
REM  --> Check for permissions
>nul 2>&1 "%SYSTEMROOT%\system32\cacls.exe" "%SYSTEMROOT%\system32\config\system"

REM --> If error flag set, we do not have admin.
if '%errorlevel%' NEQ '0' (
    echo Requesting administrative privileges...
    goto UACPrompt
) else ( goto gotAdmin )

:UACPrompt
    echo Set UAC = CreateObject^("Shell.Application"^) > "%temp%\getadmin.vbs"
    set params = %*:"=""
    echo UAC.ShellExecute "%~s0", "%params%", "", "runas", 1 >> "%temp%\getadmin.vbs"

    "%temp%\getadmin.vbs"
    exit /B

:gotAdmin
    if exist "%temp%\getadmin.vbs" ( del "%temp%\getadmin.vbs" )
    pushd "%CD%"
    CD /D "%~dp0"
:-------------------------------------


echo This script will create a mapping for your TempWorks Enterprise to your local documents and desktop.
echo.

net session >nul 2>&1
if %errorLevel% == 0 (
        
	echo You must enter your TempWorks logon name, without Host 

) else (


        echo Failure: You must run this command as Administrator
	echo Right click and select "Run as Administrator"
	echo.
        goto end

)


set /p id=Enter TempWorks Username: 
if [%id%]==[] (
	echo You must enter a Username, cannot be blank
	echo.
 ) else (
	goto usernamegiven
 )

set errorlevel=0

set /p id=Enter TempWorks Username:
if [%id%]==[] (
	echo You must enter a Username, you entered blank username twice, quiting.
	echo.
	goto end
 )
 
 
:usernamegiven 
set errorlevel=0
echo.


if not exist c:\tempworksrdp (mkdir c:\tempworksrdp)
if not exist c:\tempworksrdp\%id% (mkdir c:\tempworksrdp\%id%)
if %errorLevel% NEQ 0 (
		echo ERROR: A problem occured creating C:\TempWorksRDP\%id%
		goto end
	)

if exist c:\tempworksrdp\%id%\documents\ (rmdir c:\tempworksrdp\%id%\documents\)
if %errorLevel% NEQ 0 (
		echo ERROR: A problem occured removing previous link at c:\tempworksrdp\%id%\documents\
		goto end
	)
if exist c:\tempworksrdp\%id%\desktop\ (rmdir c:\tempworksrdp\%id%\desktop\)
if %errorLevel% NEQ 0 (
		echo ERROR: A problem occured removing previous link at c:\tempworksrdp\%id%\desktop\
		goto end
	)

if exist "%userprofile%\Documents" (
	mklink /D c:\tempworksrdp\%id%\documents "%userprofile%\Documents" >nul 2>&1
	if %errorLevel% NEQ 0 (
		echo ERROR: A problem occured creating shortcut to Documents, mklink may not be available on this system.
		goto end
	)
) else (
	echo ERROR: Could not find your local Documents directory, expected at %userprofile%\Documents
	goto end
)

if exist "%userprofile%\Desktop" (
	mklink /D c:\tempworksrdp\%id%\desktop "%userprofile%\Desktop" >nul 2>&1
	if %errorLevel% NEQ 0 (
		echo ERROR: A problem occured creating shortcut to Desktop, mklink may not be available on this system.
		goto end
	)
) else (
	echo ERROR: Could not find your local Desktop directory, expected at %userprofile%\Desktop
	goto end
)

echo Local user %username% has been mapped to TempWorks user %id%
echo.



:end
    
pause